diff -c gcc-gcc-3.4.0-orig/real.h gcc-gcc-3.4.0/real.h
*** gcc-gcc-3.4.0-orig/real.h	Fri Oct 10 20:33:05 2003
--- gcc-gcc-3.4.0/real.h	Mon Sep 27 14:06:40 2004
***************
*** 40,48 ****
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) class : 2;
    unsigned int sign : 1;
    unsigned int signalling : 1;
    unsigned int canonical : 1;
--- 40,56 ----
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
+ /* Can't have "class" in C++, but gentype gets confused on #ifdefs
+    within the struct. */
+ #ifndef __cplusplus
+ # define REAL_CLASSY class
+ #else
+ # define REAL_CLASSY cl
+ #endif
+ 
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) REAL_CLASSY : 2;
    unsigned int sign : 1;
    unsigned int signalling : 1;
    unsigned int canonical : 1;
***************
*** 50,55 ****
--- 58,65 ----
    unsigned long sig[SIGSZ];
  };
  
+ #undef REAL_CLASSY
+ 
  /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
     needs to be a macro.  We do need to continue to have a structure tag
     so that other headers can forward declare it.  */
diff -c gcc-gcc-3.4.0-orig/rtl.h gcc-gcc-3.4.0/rtl.h
*** gcc-gcc-3.4.0-orig/rtl.h	Thu Mar 25 16:44:43 2004
--- gcc-gcc-3.4.0/rtl.h	Mon Sep 27 14:06:40 2004
***************
*** 121,128 ****
--- 121,133 ----
    int rtint;
    unsigned int rtuint;
    const char *rtstr;
+ #ifndef __cplusplus
    rtx rtx;
    rtvec rtvec;
+ #else
+   rtx rt_rtx;
+   rtvec rt_vec;
+ #endif
    enum machine_mode rttype;
    addr_diff_vec_flags rt_addr_diff_vec_flags;
    struct cselib_val_struct *rt_cselib;
